--[[

Name: SphereFu
Revision: $Revision: 26721 $
Date: $Date: 2007-01-31 15:17:44 -0500 (Wed, 31 Jan 2007) $
Author(s): Somnolent (someone@somewhere.com)
Website: http://www.wowace.com/wiki/Sphere
Documentation: http://www.wowace.com/wiki/Sphere
SVN: http://svn.wowace.com/root/trunk/Sphere
Description: A FuBar Plugin for Sphere.
Dependencies: Ace2

]]--

--- ========================================================= ---
--- Check to make sure Epeen is there
--- ========================================================= ---
if not Sphere then return end

--- ========================================================= ---
--- Check to make sure FuBarPlugin 2.0 is there
--- ========================================================= ---
if not AceLibrary:HasInstance("FuBarPlugin-2.0") then return end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("SphereFu")

L:RegisterTranslations("enUS", function() return {
    ["Sphere"] = true,
	["Menu Options"] = true,
} end)

--- ========================================================= ---
--- Add Tablet
--- ========================================================= ---
local Tablet = AceLibrary("Tablet-2.0")

--- ========================================================= ---
--- Register DB for FuBar
--- ========================================================= ---

SphereFu = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0")
SphereFu.hasIcon = true
SphereFu.hasNoText = false
SphereFu.cannotDetachTooltip = true
SphereFu.hideWithoutStandby = true
SphereFu.hideMenuTitle = true
SphereFu.defaultMinimapPosition = 180
SphereFu.clickableTooltip = true
SphereFu.OnMenuRequest = Sphere.Options

Sphere.hideMenuTitle = true

SphereFu:RegisterDB("SphereFuDB")
SphereFu:RegisterDefaults("profile", {

})

--- ========================================================= ---
--- Set Images Folder
--- ========================================================= ---
Sphere_IMG = "Interface\\AddOns\\Sphere\\Images\\"

--- ========================================================= ---
--- On Enable
--- ========================================================= ---
function SphereFu:OnEnable()
	local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(self)
	if not SphereFu.OnMenuRequest.args.settings.args.FuBarMenu then
		SphereFu.OnMenuRequest.args.settings.args.FuBarMenu = {
			type = "group",
			name = L["Menu Options"],
			desc = L["Menu Options"],
			args = args,
			order = 403,
		}
	end
end