
if (not Sphere.API) then
	Sphere.API = {};
end

function Sphere.API:CreateFrame(frameType, frameName, frameParent, width, height, textureFile, enableMouse, ID)

	local tempFrame = 0;
	local tempTex = 0;

	tempFrame = CreateFrame(frameType, frameName, frameParent);
	tempFrame:SetWidth(width);
	tempFrame:SetHeight(height);
	tempFrame:EnableMouse(enableMouse);
	tempFrame:SetID(ID);

	if frameType == "Button" then
		tempFrame:SetNormalTexture(textureFile);
	end
	
	return tempFrame;

end

function Sphere.API:RotateTexture(tex, degrees, xOrigin, yOrigin)

	local radians = -math.rad(degrees - 135 );

	local sin = math.sin(radians) * 0.71;
	local cos = math.cos(radians) * 0.71;

	tex:SetTexCoord(xOrigin - sin, yOrigin + cos, xOrigin + cos, yOrigin + sin, xOrigin - cos, yOrigin - sin, xOrigin + sin, yOrigin - cos);

end