﻿--[[

Name: Sphere Buttons
Revision: $Revision: 23844 $
Date: $Date: 2007-01-07 03:01:22 -0500 (Sun, 07 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/Sphere
Documentation: http://www.wowace.com/wiki/Sphere
SVN: http://svn.wowace.com/root/trunk/Sphere
Description: A module to apply buttons around the Sphere.
Dependencies: Ace2, Sphere

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 23844 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("Buttons")

L:RegisterTranslations("enUS", function() return {
    ["Buttons"] = true,
    ["Change the Buttons Settings"] = true,
	
	["Global Settings"] = true,
    ["Change Global Settings"] = true,
	["Hide Empty Buttons"] = true,
   	["Toggle to Show/Hide Empty Buttons"] = true,
	["Compress Empty Buttons"] = true,
   	["Toggle to Compress Empty Buttons. This only works when you Hide Empty Buttons is on."] = true,
	["Show Button Cooldowns"] = true,
    ["Toggle the Button Cooldowns"] = true,
	["Show Button Usable"] = true,
   	["Toggle the Button Usable"] = true,
	["Show Button Item Counts"] = true,
   	["Toggle the Button Item Counts"] = true,
	
	["Button Settings"] = true,
	["Change the Button Settings"] = true,
	["Menu Button Settings"] = true,
	["Change the Menu Button Settings"] = true,
	["Set Menu Type"] = true,
   	["Change the way the Menu Operates"] = true,
	["Set Menu Mouse Button"] = true,
   	["Change what Mouse Button toggles the Menu"] = true,
	
	["Tooltip Settings"] =  true,
	["Change the Tooltip Settings"] = true,
	["Tooltip Type"] = true,
   	["Change what the Tooltip shows"] = true,
	["Show All the Button Toolips"] = true,
   	["Enabling this will show all the items/spells/macros attached to this button. This will not work when on Full Tooltip mode."] = true,
	["Set Tooltip Anchor Point"] = true,
   	["Change the Tooltip Anchor Point"] = true,
	
	["Button Border Colors"] = true,
	["Change Button Border Colors"] = true,
	["Item Equipped Color"] = true,
	["Change Item Equipped Color"] = true,
	["Button Hightlight Color"] = true,
	["Change Button Hightlight Color"] = true,
	
	["Cooldown Colors"] = true,
	["Change Cooldown Colors"] = true,
	["Set Cooldown Text Color"] = true,
	["Change the Cooldown Text Color"] = true,
	
	["Unusable Colors"] = true,
	["Change Unusable Colors"] = true,
	["Set Out of Range Color"] = true,
	["Change the Out of Range Color"] = true,
	["Set Out of Mana Color"] = true,
	["Change the Out of Mana Color"] = true,
	["Set Out of Range/Mana Color"] = true,
	["Change the Out of Range/Mana Color"] = true,
	["Set Unusable Color"] = true,
	["Change the Unusable Color"] = true,
	
	["Item Count Colors"] = true,
	["Change Item Count Colors"] = true,
	["Set Item Count Text Color"] = true,
	["Change the Item Count Text Color"] = true,
	
	["Bar 1 Settings"] = true,
	["Change Bar 1 Settings"] = true,
	["Bar 2 Settings"] = true,
	["Change Bar 2 Settings"] = true,
	["Bar 3 Settings"] = true,
	["Change Bar 3 Settings"] = true,
	["Bar 4 Settings"] = true,
	["Change Bar 4 Settings"] = true,
	["Bar 5 Settings"] = true,
	["Change Bar 5 Settings"] = true,
	["Bar 6 Settings"] = true,
	["Change Bar 6 Settings"] = true,
	["Bar 7 Settings"] = true,
	["Change Bar 7 Settings"] = true,
	["Bar 8 Settings"] = true,
	["Change Bar 8 Settings"] = true,
	["Bar 9 Settings"] = true,
	["Change Bar 9 Settings"] = true,
	["Bar 10 Settings"] = true,
	["Change Bar 10 Settings"] = true,
	["Bar is a Menu"] = true,
   	["Toggle if the Bar is a Menu"] = true,
	
    ["Toggle"] = true,
    ["Toggle the Module On and Off"] = true,
} end)

--- ========================================================= ---
--- Add Extra(s)
--- ========================================================= ---

local data = {
	maxSpellID = nil,
	inCombat = false,
	buttonCount = 0,
	offSet = 55,
	dragStart = false,
	dragName = nil,
	dragID = nil,
	cursoractionType = nil,
	cursorInfo1 = nil,
	cursorInfo2 = nil,
	cursorHasItem = false,
}

--- ========================================================= ---
--- Add Gratuity Library
--- ========================================================= ---
local G = AceLibrary('Gratuity-2.0')
local Deformat = AceLibrary("Deformat-2.0")

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

SphereButtons = Sphere:NewModule("Buttons")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function SphereButtons:OnInitialize()
	self.db = Sphere:AcquireDBNamespace("Buttons")

    SphereButtons.defaultDB = {
		bData = {},
		
		showcooldown = true,
		showusable = true,
		showitemcounts = true,
		tooltiptype = "full",
		showallbuttonstooltips = "yes",
		tooltipanchor = "cursor",
		
		hideempty = false,
		compressempty = false,
		
		menutype = "toggle",
		
		menubutton = {
			left = false,
			middle = false,
			right = true,
		},

		
		bar1menu = false,
		bar2menu = false,
		bar3menu = false,
		bar4menu = false,
		bar5menu = false,
		bar6menu = false,
		bar7menu = false,
		bar8menu = false,
		bar9menu = false,
		bar10menu = false,

		cooldowntextcolor = {
    		r = 1.00,
    		g = 1.00,
    		b = 0.2,
			a = 1.00,
    	},
		oorcolor = {
    		r = 0.80,
    		g = 0.10,
    		b = 0.10,
			a = 1.00,
    	},
		oomcolor = {
    		r = 0.10,
    		g = 0.30,
    		b = 1.00,
			a = 1.00,
    	},
		oormcolor = {
    		r = 0.80,
    		g = 0.20,
    		b = 0.80,
			a = 1.00,
    	},

		unusablecolor = {
    		r = 0.40,
    		g = 0.40,
    		b = 0.40,
			a = 1.00,
    	},
		itemcounttextcolor = {
    		r = 1.00,
    		g = 1.00,
    		b = 1.00,
			a = 1.00,
    	},
		
		itemequippedbordercolor = {
    		r = 0.10,
    		g = 1.00,
    		b = 0.10,
			a = 1.00,
    	},
		
		buttonhighlightbordercolor = {
    		r = 0.00,
    		g = 0.30,
    		b = 1.00,
			a = 1.00,
    	},
		
        on = true,
    }
	
	Sphere:RegisterDefaults("Buttons", "char", opts or SphereButtons.defaultDB or {})
	
    Sphere:ToggleModuleActive("Buttons", self.db.char.on)
    
	local bluecolor = "|cFF0099CC"
	local lbluecolor = "|cFF77BBFF"
	
    Sphere.Options.args.settings.args.Buttons = {
        name = L["Buttons"],
        desc = L["Change the Buttons Settings"],
		order = 101,
        type = "group",
        args = {
		     header = {
				type = "header",
				name = bluecolor..L["Buttons"].."  |c88888888"..Revision,
				icon = "Interface\\Addons\\Sphere\\icon",
				iconHeight = 14,
				iconWidth = 14,
				order = 1
            },
			blank = {
       			type = "header",
				order = 2,
			},
			
			globalsettings = {
				name = L["Global Settings"],
				desc = L["Change Global Settings"],
				order = 101,
				type = 'group',
				args = {
					generalheader = {
						type = "header",
						name = lbluecolor..L["Global Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					generalheaderblank = {
						type = 'header',
						order = 101,
					},
					buttonmenusettings = {
						name = L["Menu Button Settings"],
						desc = L["Change the Menu Button Settings"],
						order = 102,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Button Settings"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							menutype = {
	       	 					name = L["Set Menu Type"],
   	     						desc = L["Change the way the Menu Operates"],
								order = 125,
								type = "text",
    							get = function() return SphereButtons.db.char.menutype end,
    							set = function(name) SphereButtons.db.char.menutype = name; SphereButtons:ToggleMenuType(); end,
								validate = {["autohide"] = "Auto Hide", ["always"] = "Always Shown", ["toggle"] = "Toggle" }
							},
							menubutton = {
	       	 					name = L["Set Menu Mouse Button"],
   	     						desc = L["Change what Mouse Button toggles the Menu"],
								order = 125,
								type = "text",
								multiToggle = true,
								get = function(key) return SphereButtons.db.char.menubutton[key] end,
								set = function(key, value) SphereButtons.db.char.menubutton[key] = value; SphereButtons:ToggleMenuButton(); end,
								validate = {["left"] = "Left Mouse Button", ["right"] = "Right Mouse Button", ["middle"] = "Middle Mouse Button" }
							},
						},
					},
					buttonsettings = {
						name = L["Button Settings"],
						desc = L["Change the Button Settings"],
						order = 102,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Menu Button Settings"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							hideemptybuttons = {
	       	 					name = L["Hide Empty Buttons"],
   	     						desc = L["Toggle to Show/Hide Empty Buttons"],
								order = 105,
								type = "toggle",
								get = function() return SphereButtons.db.char.hideempty end,
								set = function() SphereButtons.db.char.hideempty = not(SphereButtons.db.char.hideempty); SphereButtons:ToggleHideEmptyButtons(); end
							},
							compressemptybuttons = {
								name = L["Compress Empty Buttons"],
								desc = L["Toggle to Compress Empty Buttons. This only works when you Hide Empty Buttons is on."],
								order = 106,
								type = "toggle",
								get = function() return SphereButtons.db.char.compressempty end,
								set = function() SphereButtons.db.char.compressempty = not(SphereButtons.db.char.compressempty); SphereButtons:ToggleCompressSubButtons(); end
							},
							blank = {
								type = 'header',
								order = 109,
							},
							showcooldown = {
								name = L["Show Button Cooldowns"],
								desc = L["Toggle the Button Cooldowns"],
								order = 110,
								type = "toggle",
								get = function() return SphereButtons.db.char.showcooldown end,
								set = function() SphereButtons.db.char.showcooldown = not(SphereButtons.db.char.showcooldown); SphereButtons:UpdateCooldowns(); end
							},
							showusable = {
								name = L["Show Button Usable"],
								desc = L["Toggle the Button Usable"],
								order = 111,
								type = "toggle",
								get = function() return SphereButtons.db.char.showusable end,
								set = function() SphereButtons.db.char.showusable = not(SphereButtons.db.char.showusable); SphereButtons:UpdateUsable(); end
							},
							showitemcounts = {
								name = L["Show Button Item Counts"],
								desc = L["Toggle the Button Item Counts"],
								order = 112,
								type = "toggle",
								get = function() return SphereButtons.db.char.showitemcounts end,
								set = function() SphereButtons.db.char.showitemcounts = not(SphereButtons.db.char.showitemcounts); SphereButtons:UpdateItemCounts(); end
							},
						},
					},
					tooltipblank = {
						type = 'header',
						order = 109,
					},
					tooltip = {
						name = L["Tooltip Settings"],
						desc = L["Change the Tooltip Settings"],
						order = 110,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Tooltip Settings"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							tooltipanchor = {
	       	 					name = L["Set Tooltip Anchor Point"],
   	     						desc = L["Change the Tooltip Anchor Point"],
								order = 125,
								type = "text",
    							get = function() return SphereButtons.db.char.tooltipanchor end,
    							set = function(name) SphereButtons.db.char.tooltipanchor = name end,
								validate = {["cursor"] = "Cursor", ["default"] = "Default" }
							},
							tooltiptype = {
	       	 					name = L["Tooltip Type"],
   	     						desc = L["Change what the Tooltip shows"],
								order = 126,
								type = "text",
    							get = function() return SphereButtons.db.char.tooltiptype end,
    							set = function(name) SphereButtons.db.char.tooltiptype = name end,
								validate = {["none"] = "None", ["full"] = "Full Tooltip", ["name"] = "Name Only", ["power"] = "Power Only", ["namepower"] = "Name & Power Only" }
							},
							showallbuttonstooltips = {
	       	 					name = L["Show All the Button Toolips"],
   	     						desc = L["Enabling this will show all the items/spells/macros attached to this button. This will not work when on Full Tooltip mode."],
								order = 127,
								type = "text",
    							get = function() return SphereButtons.db.char.showallbuttonstooltips end,
    							set = function(name) SphereButtons.db.char.showallbuttonstooltips = name end,
								validate = {["no"] = "No", ["yes"] = "Yes" }
							},

						},
					},
			
					buttonbordercolorsblank = {
						type = 'header',
						order = 119,
					},
					buttonbordercolors = {
						name = L["Button Border Colors"],
						desc = L["Change Button Border Colors"],
						order = 120,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Button Border Colors"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							itemequippedbordercolor = {
								name = L["Item Equipped Color"],
								desc = L["Change Item Equipped Color"],
								order = 125,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.itemequippedbordercolor.r,
									SphereButtons.db.char.itemequippedbordercolor.g,
        							SphereButtons.db.char.itemequippedbordercolor.b,
									SphereButtons.db.char.itemequippedbordercolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.itemequippedbordercolor.r,
            						SphereButtons.db.char.itemequippedbordercolor.g,
            						SphereButtons.db.char.itemequippedbordercolor.b,
									SphereButtons.db.char.itemequippedbordercolor.a
									= r, g, b, a;
									SphereButtons:UpdateUsable();
    							end,
    							hasAlpha = false
							},
							buttonhighlightbordercolor = {
								name = L["Button Hightlight Color"],
								desc = L["Change Button Hightlight Color"],
								order = 126,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.buttonhighlightbordercolor.r,
									SphereButtons.db.char.buttonhighlightbordercolor.g,
        							SphereButtons.db.char.buttonhighlightbordercolor.b,
									SphereButtons.db.char.buttonhighlightbordercolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.buttonhighlightbordercolor.r,
            						SphereButtons.db.char.buttonhighlightbordercolor.g,
            						SphereButtons.db.char.buttonhighlightbordercolor.b,
									SphereButtons.db.char.buttonhighlightbordercolor.a
									= r, g, b, a;
									SphereButtons:SetButtonHightlightBorderColor();
    							end,
    							hasAlpha = false
							},
						},
					},
					cooldowncolors = {
						name = L["Cooldown Colors"],
						desc = L["Change Cooldown Colors"],
						order = 130,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Cooldown Colors"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							cooldowntextcolor = {
								name = L["Set Cooldown Text Color"],
								desc = L["Change the Cooldown Text Color"],
								order = 126,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.cooldowntextcolor.r,
									SphereButtons.db.char.cooldowntextcolor.g,
        							SphereButtons.db.char.cooldowntextcolor.b,
									SphereButtons.db.char.cooldowntextcolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.cooldowntextcolor.r,
            						SphereButtons.db.char.cooldowntextcolor.g,
            						SphereButtons.db.char.cooldowntextcolor.b,
									SphereButtons.db.char.cooldowntextcolor.a
									= r, g, b, a;
									SphereButtons:SetCooldownTextColor();
    							end,
    							hasAlpha = true
							},
						},
					},
					usablecolors = {
						name = L["Unusable Colors"],
						desc = L["Change Unusable Colors"],
						order = 140,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Unusable Colors"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							oorcolor = {
								name = L["Set Out of Range Color"],
								desc = L["Change the Out of Range Color"],
								order = 125,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.oorcolor.r,
									SphereButtons.db.char.oorcolor.g,
        							SphereButtons.db.char.oorcolor.b,
									SphereButtons.db.char.oorcolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.oorcolor.r,
            						SphereButtons.db.char.oorcolor.g,
            						SphereButtons.db.char.oorcolor.b,
									SphereButtons.db.char.oorcolor.a
									= r, g, b, a;
									SphereButtons:UpdateUsable();
    							end,
    							hasAlpha = true
							},
							oomcolor = {
								name = L["Set Out of Mana Color"],
								desc = L["Change the Out of Mana Color"],
								order = 126,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.oomcolor.r,
									SphereButtons.db.char.oomcolor.g,
        							SphereButtons.db.char.oomcolor.b,
									SphereButtons.db.char.oomcolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.oomcolor.r,
            						SphereButtons.db.char.oomcolor.g,
            						SphereButtons.db.char.oomcolor.b,
									SphereButtons.db.char.oomcolor.a
									= r, g, b, a;
									SphereButtons:UpdateUsable();
    							end,
    							hasAlpha = true
							},
							oormcolor = {
								name = L["Set Out of Range/Mana Color"],
								desc = L["Change the Out of Range/Mana Color"],
								order = 127,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.oormcolor.r,
									SphereButtons.db.char.oormcolor.g,
        							SphereButtons.db.char.oormcolor.b,
									SphereButtons.db.char.oormcolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.oormcolor.r,
            						SphereButtons.db.char.oormcolor.g,
            						SphereButtons.db.char.oormcolor.b,
									SphereButtons.db.char.oormcolor.a
									= r, g, b, a;
									SphereButtons:UpdateUsable();
    							end,
    							hasAlpha = true
							},
							unusablecolor = {
								name = L["Set Unusable Color"],
								desc = L["Change the Unusable Color"],
								order = 128,
    							type = 'color',
    							get = function() return 
									SphereButtons.db.char.unusablecolor.r,
									SphereButtons.db.char.unusablecolor.g,
        							SphereButtons.db.char.unusablecolor.b,
									SphereButtons.db.char.unusablecolor.a
    							end,
    							set = function(r, g, b, a)
            						SphereButtons.db.char.unusablecolor.r,
            						SphereButtons.db.char.unusablecolor.g,
            						SphereButtons.db.char.unusablecolor.b,
									SphereButtons.db.char.unusablecolor.a
									= r, g, b, a;
									SphereButtons:UpdateUsable();
    							end,
    							hasAlpha = true
							},
						},
					},
					itemcountcolors = {
						name = L["Item Count Colors"],
						desc = L["Change Item Count Colors"],
						order = 150,
						type = 'group',
						args = {
							generalheader = {
								type = "header",
								name = lbluecolor..L["Item Count Colors"],
								icon = "Interface\\GossipFrame\\BinderGossipIcon",
								order = 100
							}, 
							generalheaderblank = {
								type = 'header',
								order = 101,
							},
							itemcounttextcolor = {
								name = L["Set Item Count Text Color"],
								desc = L["Change the Item Count Text Color"],
								order = 126,
								type = 'color',
								get = function() return 
									SphereButtons.db.char.itemcounttextcolor.r,
									SphereButtons.db.char.itemcounttextcolor.g,
									SphereButtons.db.char.itemcounttextcolor.b,
									SphereButtons.db.char.itemcounttextcolor.a
								end,
								set = function(r, g, b, a)
									SphereButtons.db.char.itemcounttextcolor.r,
									SphereButtons.db.char.itemcounttextcolor.g,
									SphereButtons.db.char.itemcounttextcolor.b,
									SphereButtons.db.char.itemcounttextcolor.a
									= r, g, b, a;
									SphereButtons:SetItemCountTextColor();
								end,
								hasAlpha = true
							},
						},
					},
				},
			},
			
			baroptionsblank = {
				type = 'header',
				order = 149,
			},
			
			baroptionsone = {
				name = L["Bar 1 Settings"],
				desc = L["Change Bar 1 Settings"],
				order = 151,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 1 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar1menu end,
   		     			set = function() SphereButtons.db.char.bar1menu = not(SphereButtons.db.char.bar1menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionstwo = {
				name = L["Bar 2 Settings"],
				desc = L["Change Bar 2 Settings"],
				order = 152,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 2 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar2menu end,
   		     			set = function() SphereButtons.db.char.bar2menu = not(SphereButtons.db.char.bar2menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionsthree = {
				name = L["Bar 3 Settings"],
				desc = L["Change Bar 3 Settings"],
				order = 153,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 3 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar3menu end,
   		     			set = function() SphereButtons.db.char.bar3menu = not(SphereButtons.db.char.bar3menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionsfour = {
				name = L["Bar 4 Settings"],
				desc = L["Change Bar 4 Settings"],
				order = 154,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 4 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar4menu end,
   		     			set = function() SphereButtons.db.char.bar4menu = not(SphereButtons.db.char.bar4menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionsfive = {
				name = L["Bar 5 Settings"],
				desc = L["Change Bar 5 Settings"],
				order = 155,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 5 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar5menu end,
   		     			set = function() SphereButtons.db.char.bar5menu = not(SphereButtons.db.char.bar5menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionssix = {
				name = L["Bar 6 Settings"],
				desc = L["Change Bar 6 Settings"],
				order = 156,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 6 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar6menu end,
   		     			set = function() SphereButtons.db.char.bar6menu = not(SphereButtons.db.char.bar6menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionsseven = {
				name = L["Bar 7 Settings"],
				desc = L["Change Bar 7 Settings"],
				order = 157,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 7 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar7menu end,
   		     			set = function() SphereButtons.db.char.bar7menu = not(SphereButtons.db.char.bar7menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionseight = {
				name = L["Bar 8 Settings"],
				desc = L["Change Bar 8 Settings"],
				order = 158,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 8 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar8menu end,
   		     			set = function() SphereButtons.db.char.bar8menu = not(SphereButtons.db.char.bar8menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionsnine = {
				name = L["Bar 9 Settings"],
				desc = L["Change Bar 9 Settings"],
				order = 159,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 9 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar9menu end,
   		     			set = function() SphereButtons.db.char.bar9menu = not(SphereButtons.db.char.bar9menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			baroptionsten = {
				name = L["Bar 10 Settings"],
				desc = L["Change Bar 10 Settings"],
				order = 160,
				type = 'group',
				args = {
					baroptionsheader = {
						type = "header",
						name = lbluecolor..L["Bar 10 Settings"],
						icon = "Interface\\GossipFrame\\BinderGossipIcon",
						order = 100
					}, 
					baroptionsheaderblank = {
						type = 'header',
						order = 101,
					},
					barmenu = {
	       	 			name = L["Bar is a Menu"],
   	     				desc = L["Toggle if the Bar is a Menu"],
						order = 102,
   	     				type = "toggle",
   	    	 			get = function() return SphereButtons.db.char.bar10menu end,
   		     			set = function() SphereButtons.db.char.bar10menu = not(SphereButtons.db.char.bar10menu); SphereButtons:ToggleMenuButton(); end
					},
				},
			},
			
			toggleblank = {
				type = 'header',
				order = 199,
			},
            toggle = {
                name = L["Toggle"],
                desc = L["Toggle the Module On and Off"],
				order = 200,
                type = "toggle",
                get = function() return self.db.char.on end,
                set = function() self.db.char.on = Sphere:ToggleModuleActive("Buttons") end
            }
        }
    }
	
	SphereButtons:CreateFrames()
	
end

--- ========================================================= ---
--- On Enable
--- ========================================================= ---

function SphereButtons:OnEnable()

	self:RegisterEvent('PLAYER_REGEN_DISABLED')
	self:RegisterEvent('PLAYER_REGEN_ENABLED')
	self:RegisterEvent('CURSOR_UPDATE')
	self:RegisterEvent('ITEM_LOCK_CHANGED')
	self:RegisterEvent('ACTIONBAR_SHOWGRID')
	self:RegisterEvent('ACTIONBAR_HIDEGRID')
	
	self:RegisterEvent('SPELL_UPDATE_USABLE')
	self:RegisterEvent('UPDATE_INVENTORY_ALERTS')
	self:RegisterEvent('SPELL_UPDATE_COOLDOWN')
	self:RegisterEvent('BAG_UPDATE_COOLDOWN')
	self:RegisterEvent('PLAYER_TARGET_CHANGED')
	self:RegisterEvent('PLAYER_AURAS_CHANGED')
	self:RegisterEvent('UNIT_INVENTORY_CHANGED')
	self:RegisterEvent('BAG_UPDATE')
	
	self:ScheduleRepeatingEvent("UpdateButtons", self.UpdateButtons, 1, self)

	data.maxSpellID = self:FindMaxID()
	
	SphereButtons:InsureAllLoaded()

end

--- ========================================================= ---
--- On Disable
--- ========================================================= ---

function SphereButtons:OnDisable()
	self:UnregisterAllEvents();

end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function SphereButtons:ResetDB()
	copyTable(self.db.char, SphereButtons.defaultDB)
end

--- ========================================================= ---
--- Insure All Loaded
--- ========================================================= ---

function SphereButtons:InsureAllLoaded()

	for index=1, data.buttonCount do
		SphereButtons:LoadButton(index)
	end
	
end

--- ========================================================= ---
--- Find Max Spell ID
--- ========================================================= ---

function SphereButtons:FindMaxID()
	local id = 10
	while GetSpellTexture(id, BOOKTYPE_SPELL) do
		id = id + 1
	end
	return id
end

--- ========================================================= ---
--- Spell Name TO Spell ID
--- ========================================================= ---

function SphereButtons:GetSpellInfo(spellName)
	for i = data.maxSpellID, 1, -1 do
		if (GetSpellName(i, BOOKTYPE_SPELL)) == spellName then
			return i
		end
	end
end

--- ========================================================= ---
--- PLAYER_REGEN_DISABLED
--- ========================================================= ---

function SphereButtons:PLAYER_REGEN_DISABLED()

	data.inCombat = true;
	SphereButtons:HideEmptyButtons()
	
end

--- ========================================================= ---
--- PLAYER_REGEN_ENABLED
--- ========================================================= ---

function SphereButtons:PLAYER_REGEN_ENABLED()

	data.inCombat = false;
	
end

--- ========================================================= ---
--- CURSOR_UPDATE
--- ========================================================= ---

function SphereButtons:CURSOR_UPDATE()

	SphereButtons:CursorStatusChanged()
	
end

--- ========================================================= ---
--- ITEM_LOCK_CHANGED
--- ========================================================= ---

function SphereButtons:ITEM_LOCK_CHANGED()

	SphereButtons:CursorStatusChanged()
	
end

--- ========================================================= ---
--- ACTIONBAR_SHOWGRID
--- ========================================================= ---

function SphereButtons:ACTIONBAR_SHOWGRID()

	SphereButtons:CursorStatusChanged()
	
end

--- ========================================================= ---
--- ACTIONBAR_HIDEGRID
--- ========================================================= ---

function SphereButtons:ACTIONBAR_HIDEGRID()

	SphereButtons:HideEmptyButtons()
	
end

--- ========================================================= ---
--- SPELL_UPDATE_USABLE
--- ========================================================= ---

function SphereButtons:SPELL_UPDATE_USABLE()

	SphereButtons:UpdateCooldowns()
	SphereButtons:UpdateUsable()
	
end

--- ========================================================= ---
--- UPDATE_INVENTORY_ALERTS
--- ========================================================= ---

function SphereButtons:UPDATE_INVENTORY_ALERTS()

	SphereButtons:UpdateCooldowns()
	SphereButtons:UpdateUsable()
	
end

--- ========================================================= ---
--- SPELL_UPDATE_COOLDOWN
--- ========================================================= ---

function SphereButtons:SPELL_UPDATE_COOLDOWN()

	SphereButtons:UpdateCooldowns()
	SphereButtons:UpdateUsable()
	
end

--- ========================================================= ---
--- BAG_UPDATE_COOLDOWN
--- ========================================================= ---

function SphereButtons:BAG_UPDATE_COOLDOWN()

	SphereButtons:UpdateCooldowns()
	SphereButtons:UpdateUsable()
	
end

--- ========================================================= ---
--- PLAYER_TARGET_CHANGED
--- ========================================================= ---

function SphereButtons:PLAYER_TARGET_CHANGED()

	SphereButtons:UpdateUsable()
	
end

--- ========================================================= ---
--- PLAYER_AURAS_CHANGED
--- ========================================================= ---

function SphereButtons:PLAYER_AURAS_CHANGED()

	SphereButtons:UpdateUsable()
	
end

--- ========================================================= ---
--- UNIT_INVENTORY_CHANGED
--- ========================================================= ---

function SphereButtons:UNIT_INVENTORY_CHANGED()

	SphereButtons:UpdateItemCounts()
	
end

--- ========================================================= ---
--- BAG_UPDATE
--- ========================================================= ---

function SphereButtons:BAG_UPDATE()

	SphereButtons:UpdateItemCounts()
	
end

--- ========================================================= ---
--- Set Cooldown Text Color
--- ========================================================= ---

function SphereButtons:SetCooldownTextColor()

	for index=1, data.buttonCount do
		local buttonName = SphereButtons.db.char.bData[index].buttonname
		
		if not(SphereButtons.db.char.bData[index].empty) then 
		
			getglobal(buttonName).cooldownText:SetTextColor(SphereButtons.db.char.cooldowntextcolor.r, SphereButtons.db.char.cooldowntextcolor.g, SphereButtons.db.char.cooldowntextcolor.b, SphereButtons.db.char.cooldowntextcolor.a)
			
		end
		
	end
	
end

--- ========================================================= ---
--- Set Item Count Text Color
--- ========================================================= ---

function SphereButtons:SetItemCountTextColor()

	for index=1, data.buttonCount do
		local buttonName = SphereButtons.db.char.bData[index].buttonname
		
		if not(SphereButtons.db.char.bData[index].empty) then 
		
			getglobal(buttonName .. "Count"):SetTextColor(SphereButtons.db.char.itemcounttextcolor.r, SphereButtons.db.char.itemcounttextcolor.g, SphereButtons.db.char.itemcounttextcolor.b, SphereButtons.db.char.itemcounttextcolor.a)
			
		end
		
	end
	
end

--- ========================================================= ---
--- Set Button Hightlight Border Color
--- ========================================================= ---

function SphereButtons:SetButtonHightlightBorderColor()

	for index=1, data.buttonCount do
		local buttonName = SphereButtons.db.char.bData[index].buttonname
		
		if not(SphereButtons.db.char.bData[index].empty) then 
		
				getglobal(buttonName):GetHighlightTexture():SetVertexColor(SphereButtons.db.char.buttonhighlightbordercolor.r, SphereButtons.db.char.buttonhighlightbordercolor.g, SphereButtons.db.char.buttonhighlightbordercolor.b, SphereButtons.db.char.buttonhighlightbordercolor.a);

		end
		
	end
	
end

--- ========================================================= ---
--- Create Button
--- ========================================================= ---

function SphereButtons:CreateButton(buttonName, buttonAnchor)

	data.buttonCount = data.buttonCount + 1;
	
	local b
	local background, highlight, pushed, checked, icon, border, count;

	b = CreateFrame("CheckButton", buttonName, getglobal(buttonAnchor), "SecureActionButtonTemplate, SecureAnchorUpDownTemplate, ActionButtonTemplate")
	b:RegisterForClicks("AnyUp")
	b:RegisterForDrag("LeftButton", "MiddleButton", "RightButton", "Button4", "Button5")
	
	b:SetAttribute("statebutton1", "S01");
	b:SetAttribute("statebutton2", "S02");
	b:SetAttribute("statebutton3", "S03");
	
	b:SetScript("OnUpdate", nil);
	b:SetScript("OnShow", nil);
	
	b:SetScript("OnEnter", function(self) 
	
			if GetCursorInfo() then
				local actionType, info1, info2 = GetCursorInfo()
				data.cursorHasItem = true
				data.cursoractionType =  actionType
				data.cursorInfo1 =  info1
				data.cursorInfo2 =  info2
			else
				data.cursoractionType =  nil
				data.cursorInfo1 =  nil
				data.cursorInfo2 =  nil
			end
	
			SphereButtons:SetTooltip(this)
	
		end)
		
	b:SetScript("OnLeave", function()
	
			if (data.inCombat == false) and not(Sphere.db.char.lock) then
	
				if (not(GetCursorInfo()) and (data.cursorHasItem)) then
					SphereButtons:SetButtonAssign(this, 2, data.cursoractionType, data.cursorInfo1, data.cursorInfo2)
					data.cursorHasItem = false
				end

			end
			
			GameTooltip:Hide() 
			
		end)
	
	b:SetScript("OnDragStart", function() 
			
			if (data.inCombat == false) and not(Sphere.db.char.lock) then
			
				local clickType = 1;
				if (arg1 == "RightButton") then
					clickType = 2;
				end
				if (arg1 == "MiddleButton") then
					clickType = 3;
				end
			
				data.dragStart = true;
				data.dragName = this:GetName();
				data.dragID = this:GetID();
			
				SphereButtons:dragStart(this, data.dragID, data.dragName, clickType);
				
			end
			
		end)
		
	b:SetScript("OnDragStop", function(self) 
			
			if (data.inCombat == false) and not(Sphere.db.char.lock) then
			
				data.dragStart = false;
				data.dragName = nil;
				data.dragID = nil;
				
			end
			
		end)
	
	b:SetScript("OnReceiveDrag", function(self) 
	
		end)
	
	b:SetScript("PreClick", function(self)
			
			if (data.inCombat == false) and not(Sphere.db.char.lock) then
				
				self:SetChecked(1)
				
				if ((GetCursorInfo()) or (data.cursoractionType)) then
					local clickType = 1;
					if (arg1 == "RightButton") then
						clickType = 2;
					end
					if (arg1 == "MiddleButton") then
						clickType = 3;
					end
				
					local actionType, info1, info2
				
					if GetCursorInfo() then
						actionType, info1, info2 = GetCursorInfo()
					elseif data.cursoractionType then
						actionType = data.cursoractionType
						info1 = data.cursorInfo1
						info2 = data.cursorInfo2
					end
				
					b:SetScript("OnUpdate", function () SphereButtons:SetButtonAssign(this, clickType, actionType, info1, info2); end);
					
					data.cursorHasItem = false
					data.cursoractionType =  nil
					data.cursorInfo1 =  nil
					data.cursorInfo2 =  nil
				end

			end
			
		end)
		
	b:SetScript("PostClick", function(self)
	
			self:SetChecked(nil)
	
		end)
	
	b:SetNormalTexture("Interface\\Addons\\Sphere\\Art\\button");
	b:SetPushedTexture("Interface\\Addons\\Sphere\\Art\\button");
	b:SetCheckedTexture("Interface\\Addons\\Sphere\\Art\\button");
	b:SetHighlightTexture("Interface\\Addons\\Sphere\\Art\\button");
	
	b:GetCheckedTexture():SetVertexColor(SphereButtons.db.char.itemequippedbordercolor.r, SphereButtons.db.char.itemequippedbordercolor.g, SphereButtons.db.char.itemequippedbordercolor.b, SphereButtons.db.char.itemequippedbordercolor.a);
	b:GetHighlightTexture():SetVertexColor(SphereButtons.db.char.buttonhighlightbordercolor.r, SphereButtons.db.char.buttonhighlightbordercolor.g, SphereButtons.db.char.buttonhighlightbordercolor.b, SphereButtons.db.char.buttonhighlightbordercolor.a);
	
	background = b:GetNormalTexture();
	pushed = b:GetPushedTexture();
	checked = b:GetCheckedTexture();
	highlight = b:GetHighlightTexture();
	border = getglobal(buttonName.."Border");
	icon = getglobal(buttonName.."Icon");
	count = getglobal(buttonName.."Count");
	
	background:ClearAllPoints();
	background:SetWidth(32);
	background:SetHeight(32);
	background:SetPoint("CENTER", 0, 0);
	
	pushed:ClearAllPoints();
	pushed:SetWidth(32);
	pushed:SetHeight(32);
	pushed:SetPoint("CENTER", 0, 0);
	
	checked:ClearAllPoints();
	checked:SetWidth(32);
	checked:SetHeight(32);
	checked:SetPoint("CENTER", 0, -1);
	
	highlight:ClearAllPoints();
	highlight:SetWidth(32);
	highlight:SetHeight(32);
	highlight:SetPoint("CENTER", 0, -1);
	
	border:SetTexture(highlight:GetTexture());
	border:ClearAllPoints();
	border:SetWidth(32);
	border:SetHeight(32);
	border:SetPoint("CENTER", 0, 0);
	
	icon:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background");
	SetPortraitToTexture(icon, icon:GetTexture());
	icon:ClearAllPoints();
	icon:SetWidth(25);
	icon:SetHeight(25);
	icon:SetAlpha(0.5);
	icon:SetPoint("CENTER", b, "CENTER", 0, 0);
	
	count:SetTextColor(SphereButtons.db.char.itemcounttextcolor.r, SphereButtons.db.char.itemcounttextcolor.g, SphereButtons.db.char.itemcounttextcolor.b, SphereButtons.db.char.itemcounttextcolor.a)
	count:SetText("");
	count:Hide();

	b.cooldownText = b:CreateFontString(this:GetName() .. "CooldownText", "OVERLAY")
	b.cooldownText:SetFont(STANDARD_TEXT_FONT, 14, "OUTLINE")
	b.cooldownText:SetTextColor(SphereButtons.db.char.cooldowntextcolor.r, SphereButtons.db.char.cooldowntextcolor.g, SphereButtons.db.char.cooldowntextcolor.b, SphereButtons.db.char.cooldowntextcolor.a)
	b.cooldownText:SetPoint("CENTER")
	b.cooldownText:SetText("")
	b.cooldownText:Hide()

	b:SetToplevel(false);

	return b
end

--- ========================================================= ---
--- Create Frames
--- ========================================================= ---

function SphereButtons:CreateFrames()

	sHeader = CreateFrame("Frame", "SphereButtonHeader", getglobal("SphereMain"), "SecureStateHeaderTemplate, SecureStateDriverTemplate")
	sHeader:SetAllPoints(getglobal("SphereMain"));
	sHeader:SetAttribute('state', 0);

	local nB, mHeader, parentButton, xLoc, yLoc, radians, index, menuIndex;
	local xOffset, xDir;

	for index=1, 10 do
		buttonName = "SphereMenu"..index.."Button"
		nB = SphereButtons:CreateButton(buttonName, "SphereMain");
		nB:Hide();
		
		radians = -math.rad(((index-1) * 36) - 90);
		xLoc = data.offSet * math.cos(radians)
		yLoc = data.offSet * math.sin(radians)

		nB:SetID(data.buttonCount);
		
		nB:SetPoint("CENTER", xLoc, yLoc);
		nB:SetScale(1.00);
		
		mHeader = CreateFrame("Frame", "SphereMenu" .. index .. "ButtonHeader", nB, "SecureStateHeaderTemplate, SecureStateDriverTemplate")
		mHeader:SetAllPoints(nB);
		
        nB:SetAttribute('childraise1', true);
        nB:SetAttribute('childstate1', '$input');

		if (SphereButtons.db.char["bar"..index.."menu"]) then
			if (SphereButtons.db.char.menubutton.left) then
				nB:SetAttribute('onmousedownbutton1', 'buttondown');
				nB:SetAttribute('onmouseupbutton1', 'buttonup');
			end
			if (SphereButtons.db.char.menubutton.right) then
				nB:SetAttribute('onmousedownbutton2', 'buttondown');
				nB:SetAttribute('onmouseupbutton2', 'buttonup');
			end
			if (SphereButtons.db.char.menubutton.middle) then
				nB:SetAttribute('onmousedownbutton3', 'buttondown');
				nB:SetAttribute('onmouseupbutton3', 'buttonup');
			end
		end
		
		nB:SetAttribute('anchorchild-buttondown', mHeader);
		nB:SetAttribute('childstate-buttondown', '^mousedown');
		nB:SetAttribute('childreparent-buttondown', true);

		nB:SetAttribute('anchorchild-buttonup', mHeader);
		nB:SetAttribute('childstate-buttonup', 'mouseup');
		nB:SetAttribute('childverify-buttonup', true);

		mHeader:SetAttribute('state', 0);
		
		mHeader:SetAttribute('statemap-anchor-mousedown', '0-1');
		mHeader:SetAttribute('statemap-anchor-mouseup', '1:');
		mHeader:SetAttribute('delaystatemap-anchor', '0');
		mHeader:SetAttribute('delaytimemap-anchor', "");
		mHeader:SetAttribute('delayhovermap-anchor', 'true');

		nB:SetAttribute('onmouseupbutton1', '');
		
		sHeader:SetAttribute("addchild", nB);

		if (SphereButtons.db.char.bData[data.buttonCount]) then
			if not(SphereButtons.db.char.bData[data.buttonCount].empty) then
				SphereButtons:LoadButton(data.buttonCount);
			end
		else
			SphereButtons.db.char.bData[data.buttonCount] = {};
			SphereButtons.db.char.bData[data.buttonCount].empty = true
			SphereButtons.db.char.bData[data.buttonCount].buttonid = data.buttonCount
			SphereButtons.db.char.bData[data.buttonCount].buttonname = buttonName
		end
		
		if (SphereButtons.db.char["bar"..index.."menu"]) then
			nB:Show();
		else
			if (SphereButtons.db.char.bData[data.buttonCount].empty) then
				nB:Hide();
			end
		end
		
	end
	
	-- Sub Buttons
	
	index = 0;
	local offsetY = {28, 6, 0, 0, -6, -28, -6, 0, 0, 6}

	for menuIndex = 1, 10 do 
	
		menuButton = getglobal("SphereMenu" .. menuIndex .. "Button")
		
		xDir = 1;
		if (menuIndex > 6) then
			xDir = -1;
		end
		
		for xLoc = 0, (320 - 32), 32 do 

			if (index >= 10) then
				index = 1
			else
				index = index + 1;
			end
				
			buttonName = "SphereMenu"..menuIndex.."SubButton"..index
			nB = SphereButtons:CreateButton(buttonName, "SphereMain");
			
			if (xDir == 1) then
				if (xLoc == 0) then
					nB:SetPoint("LEFT", menuButton, "RIGHT", 0, offsetY[menuIndex]);
				else
					nB:SetPoint("LEFT", getglobal("SphereMenu" .. tostring(menuIndex) .. "SubButton" .. tostring(index - 1)), "RIGHT", -4, 0);
				end
			else
				if (xLoc == 0) then
					nB:SetPoint("RIGHT", menuButton, "LEFT", 0, offsetY[menuIndex]);
				else
					nB:SetPoint("RIGHT", getglobal("SphereMenu" .. tostring(menuIndex) .. "SubButton" .. tostring(index - 1)), "LEFT", 4, 0);
				end
			end
			
			nB:SetAttribute("showstates", "!0,!1");
			nB:Show();
			
			if (SphereButtons.db.char.compressempty) then
				nB:SetWidth(4);
				nB:SetAttribute("width", 4);
			end
			
			if (SphereButtons.db.char.bData[data.buttonCount]) then
				if not(SphereButtons.db.char.bData[data.buttonCount].empty) then
					SphereButtons:LoadButton(data.buttonCount);
				end
			else
				SphereButtons.db.char.bData[data.buttonCount] = {};
				SphereButtons.db.char.bData[data.buttonCount].empty = true
				SphereButtons.db.char.bData[data.buttonCount].buttonid = data.buttonCount
				SphereButtons.db.char.bData[data.buttonCount].buttonname = buttonName
			end
			
			nB:SetID(data.buttonCount);
			
			getglobal("SphereMenu" .. menuIndex .. "ButtonHeader"):SetAttribute("addchild", nB);
			getglobal("SphereMenu" .. menuIndex .. "Button"):SetAttribute("addchild", nB);
			
		end
		
	end
	
	SphereButtons:ToggleMenuType()
	SphereButtons:ToggleHideEmptyButtons()

end

--- ========================================================= ---
--- Toggle Menu Button
--- ========================================================= ---

function SphereButtons:ToggleMenuButton()

	local index;
	for index = 1, 10 do 
		local buttonName = SphereButtons.db.char.bData[index].buttonname
		
		getglobal(buttonName):SetAttribute('onmousedownbutton1', "");
		getglobal(buttonName):SetAttribute('onmouseupbutton1', "");
		getglobal(buttonName):SetAttribute('onmousedownbutton2', "");
		getglobal(buttonName):SetAttribute('onmouseupbutton2', "");
		getglobal(buttonName):SetAttribute('onmousedownbutton3', "");
		getglobal(buttonName):SetAttribute('onmouseupbutton3', "");
		
		if (SphereButtons.db.char["bar"..index.."menu"]) then
			if (SphereButtons.db.char.menubutton.left) then
				getglobal(buttonName):SetAttribute('onmousedownbutton1', 'buttondown');
				getglobal(buttonName):SetAttribute('onmouseupbutton1', 'buttonup');
			end
			if (SphereButtons.db.char.menubutton.right) then
				getglobal(buttonName):SetAttribute('onmousedownbutton2', 'buttondown');
				getglobal(buttonName):SetAttribute('onmouseupbutton2', 'buttonup');
			end
			if (SphereButtons.db.char.menubutton.middle) then
				getglobal(buttonName):SetAttribute('onmousedownbutton3', 'buttondown');
				getglobal(buttonName):SetAttribute('onmouseupbutton3', 'buttonup');
			end
		end
		
		if (SphereButtons.db.char.hideempty) then
			if ((SphereButtons.db.char.bData[index].empty) and not(SphereButtons.db.char["bar"..index.."menu"])) then
				getglobal(buttonName):Hide();
			elseif ((SphereButtons.db.char.bData[index].empty) and (SphereButtons.db.char["bar"..index.."menu"])) then
				getglobal(buttonName):Show();
			end
		else
			if (SphereButtons.db.char.bData[index].empty) then
				getglobal(buttonName):Show();
			end
		end
		
		SphereButtons:ToggleMenuType()
		
	end
	
end

--- ========================================================= ---
--- Toggle Menu Auto Hide
--- ========================================================= ---

function SphereButtons:ToggleMenuType()

	local index;
	for index = 1, 10 do 
		if (SphereButtons.db.char.menutype == "autohide") then
			getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('delaytimemap-anchor', '3');
			getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('state', 0);
		elseif (SphereButtons.db.char.menutype == "toggle") then
			getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('delaytimemap-anchor', "");
		elseif (SphereButtons.db.char.menutype == "always") then
			getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('delaytimemap-anchor', "");
			if (SphereButtons.db.char["bar"..index.."menu"]) then
				getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('state', 1);
			else
				getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('state', 0);
			end
		end
	end
	
end

--- ========================================================= ---
--- Toggle Compress Sub Buttons
--- ========================================================= ---

function SphereButtons:ToggleCompressSubButtons()

	local index;
	for index = 11, 110 do
		
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
		buttonName:SetAttribute("showstates", "!0,1");

		if (SphereButtons.db.char.bData[index].empty) then
			buttonName:SetAttribute("showstates", "!0,!1");
			
			if (SphereButtons.db.char.compressempty) then
				buttonName:SetWidth(4);
			else
				buttonName:SetWidth(36);
			end
		end

	end
	
	SphereButtons:ToggleHideEmptyButtons()

end

--- ========================================================= ---
--- Toggle Hide Empty Buttons
--- ========================================================= ---

function SphereButtons:ToggleHideEmptyButtons()

	local index;
	for index = 11, 110 do
		
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
		
		if (SphereButtons.db.char.hideempty) then
		
			buttonName:SetAttribute("showstates", "!0,1");

			if (SphereButtons.db.char.bData[index].empty) then
				buttonName:SetAttribute("showstates", "!0,!1");
			
				if (SphereButtons.db.char.compressempty) then
					buttonName:SetWidth(4);
				else
					buttonName:SetWidth(36);
				end
			end
			
		else
		
			buttonName:SetAttribute("showstates", "!0,1"); 
	
			if (SphereButtons.db.char.bData[index].empty) then
				buttonName:SetAlpha(0.5);
				buttonName:SetWidth(36);
				buttonName:SetAttribute("width", 36);
			end
			
		end
	
	end
	
	for index = 1, 10 do 
	
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
		
		if (SphereButtons.db.char.hideempty) then
			if ((SphereButtons.db.char.bData[index].empty) and not(SphereButtons.db.char["bar"..index.."menu"])) then
				buttonName:Hide();
			end
		else
			if (SphereButtons.db.char.bData[index].empty) then
				buttonName:Show();
			end
		end

		getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('state', 
		getglobal("SphereMenu" .. index .. "ButtonHeader"):GetAttribute('state'));
	end

end

--- ========================================================= ---
--- Cursor Status Changed
--- ========================================================= ---

function SphereButtons:CursorStatusChanged()

	if (data.inCombat == false) and not(Sphere.db.char.lock) then
		if (GetCursorInfo()) then
			SphereButtons:ShowEmptyButtons();
		else
			SphereButtons:HideEmptyButtons();
		end
	end			

end

--- ========================================================= ---
--- Show Empty Buttons
--- ========================================================= ---

function SphereButtons:ShowEmptyButtons()

	local index;
	for index = 11, 110 do
		
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
	
		buttonName:SetAttribute("showstates", "!0,1"); 
	
		if (SphereButtons.db.char.bData[index].empty) then
			buttonName:SetAlpha(0.5);
			buttonName:SetWidth(36);
			buttonName:SetAttribute("width", 36);
		end
			
	end
	
	for index = 1, 10 do 
	
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
		
		if (SphereButtons.db.char.bData[index].empty) then
			buttonName:Show();
		end

		getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('state', 
		getglobal("SphereMenu" .. index .. "ButtonHeader"):GetAttribute('state'));
	end

end

--- ========================================================= ---
--- Hide Empty Buttons
--- ========================================================= ---

function SphereButtons:HideEmptyButtons()

	local index;
	for index = 11, 110 do
		
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
		
		if (SphereButtons.db.char.hideempty) then
		
			buttonName:SetAttribute("showstates", "!0,1");

			if (SphereButtons.db.char.bData[index].empty) then
				buttonName:SetAttribute("showstates", "!0,!1");
			
				if (SphereButtons.db.char.compressempty) then
					buttonName:SetWidth(4);
				else
					buttonName:SetWidth(36);
				end
			end
			
		end

	end
	
	for index = 1, 10 do 
	
		local buttonName = getglobal(SphereButtons.db.char.bData[index].buttonname)
		
		if (SphereButtons.db.char.hideempty) then
		
			if ((SphereButtons.db.char.bData[index].empty) and not(SphereButtons.db.char["bar"..index.."menu"])) then
				buttonName:Hide();
			end
			
		end

		getglobal("SphereMenu" .. index .. "ButtonHeader"):SetAttribute('state', 
		getglobal("SphereMenu" .. index .. "ButtonHeader"):GetAttribute('state'));
	end

end

--- ========================================================= ---
--- Create Spell Info for the Tooltip
--- ========================================================= ---

function SphereButtons:CreateSpellTooltip(name)

	local type, amount
	
	local spellid = SphereButtons:GetSpellInfo(name)

	G:SetSpell(spellid, "spell")
	if (G:Find('(%d+)%s'..MANA, 2, 2, false, true)) then
		local mana = tonumber(select(3, G:Find('(%d+)%s'..MANA, 2, 2, false, true))) or 0
				
		type = "Mana"
		amount = mana
		
	elseif (G:Find('(%d+)%s'..ENERGY, 2, 2, false, true)) then
		local energy = tonumber(select(3, G:Find('(%d+)%s'..ENERGY, 2, 2, false, true))) or 0
				
		type = "Energy"
		amount = energy
		
	elseif (G:Find('(%d+)%s'..RAGE, 2, 2, false, true)) then
		local rage = tonumber(select(3, G:Find('(%d+)%s'..RAGE, 2, 2, false, true))) or 0
				
		type = "Rage"
		amount = rage
	end
	
	return type, amount

end

--- ========================================================= ---
--- Create Item Info for the Tooltip
--- ========================================================= ---

function SphereButtons:CreateItemTooltip(name)

	local iA, iB, iT

	local b, s, i = nil;
	local iBag, iSlot = nil;
	local iInv = nil;
		
	for b=0,4 do
		for s=1,GetContainerNumSlots(b) do
			if GetContainerItemLink(b,s) then
				if string.find(GetContainerItemLink(b,s),name) then
					iBag = b
					iSlot = s
				end
			end
		end
	end
		
	if ((iBag == nil) and (iSlot == nil)) then
		for i=0,23 do
			if GetInventoryItemLink("player",i) then
				if string.find(GetInventoryItemLink("player",i),name) then
					iInv = i
				end
			end
		end
	end
		
	if ((iBag) and (iSlot)) then
		iA = iBag
		iB = iSlot
		--GameTooltip:SetBagItem(iBag, iSlot);
		iT = "bag"
	elseif (iInv) then
		iA = "player"
		iB = iInv
		--GameTooltip:SetInventoryItem("player", iInv)
		iT = "inv"
	end
		
	return iA, iB, iT

end

--- ========================================================= ---
--- Create Tooltip
--- ========================================================= ---

function SphereButtons:SetTooltip(this)

	if (not this) then
		return;
	end

	local buttonID = this:GetID();
	local buttonName = this:GetName();
	
	local actionType, actionType2, actionType3
	local name, name2, name3
	
	test = buttonID
	testpos = buttonName
	
	if (SphereButtons.db.char.bData[buttonID].actionType1) then
		actionType = SphereButtons.db.char.bData[buttonID].actionType1
	end
	if (SphereButtons.db.char.bData[buttonID].actionType2) then
		actionType2 = SphereButtons.db.char.bData[buttonID].actionType2
	end
	if (SphereButtons.db.char.bData[buttonID].actionType3) then
		actionType3 = SphereButtons.db.char.bData[buttonID].actionType3
	end
	
	if (SphereButtons.db.char.bData[buttonID].actionName1) then
		name = SphereButtons.db.char.bData[buttonID].actionName1
	end
	if (SphereButtons.db.char.bData[buttonID].actionName2) then
		name2 = SphereButtons.db.char.bData[buttonID].actionName2
	end
	if (SphereButtons.db.char.bData[buttonID].actionName3) then
		name3 = SphereButtons.db.char.bData[buttonID].actionName3
	end

	GameTooltip:ClearLines();
	
	if (SphereButtons.db.char.tooltipanchor == "cursor") then
		GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
	elseif (SphereButtons.db.char.tooltipanchor == "default") then
		GameTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
	end
	
	if (SphereButtons.db.char.tooltiptype == "full") then
		
		if (actionType == "spell") then
	
			local spellid = SphereButtons:GetSpellInfo(name)
			GameTooltip:SetSpell(spellid, "spell")
			
		elseif (actionType == "item") then

			local iA, iB, iT = SphereButtons:CreateItemTooltip(name)
			
			if (iT == "bag") then
				GameTooltip:SetBagItem(iA, iB);
			elseif (iT == "inv") then
				GameTooltip:SetInventoryItem(iA, iB);
			end

		elseif (actionType == "macro") then
			
			local macroName, texture, macrobody, localVar = GetMacroInfo(name);
		
			GameTooltip:SetText(macroName, 1.00, 1.00, 0.00, 1)
			GameTooltip:AddLine(macrobody, 1.00, 1.00, 1.00, 1)
		
		end
		
	else

		if (actionType == "spell") then
		
			if (SphereButtons.db.char.tooltiptype == "name") then
				
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine("Left Click", 1.00, 1.00, 0.00, 1)
				end
				
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine(name, 1.00, 1.00, 1.00, 1)
				else
					GameTooltip:AddLine(name, 1.00, 1.00, 0.00, 1)
				end

			elseif (SphereButtons.db.char.tooltiptype == "power") then
				
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine("Left Click", 1.00, 1.00, 0.00, 1)
				end
				
				local type, amount = SphereButtons:CreateSpellTooltip(name)

				if ((SphereButtons.db.char.showallbuttonstooltips == "yes") and (type) and (amount)) then
					GameTooltip:AddLine(amount.." "..type, 1.00, 1.00, 1.00, 1)
				elseif ((type) and (amount)) then
					GameTooltip:AddLine(amount.." "..type, 1.00, 1.00, 0.00, 1)
				end

			elseif (SphereButtons.db.char.tooltiptype == "namepower") then
			
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine("Left Click", 1.00, 1.00, 0.00, 1)
				end
				
				local type, amount = SphereButtons:CreateSpellTooltip(name)

				if ((SphereButtons.db.char.showallbuttonstooltips == "yes") and (type) and (amount)) then
					GameTooltip:AddLine(name.." - "..amount.." "..type, 1.00, 1.00, 1.00, 1)
				elseif ((type) and (amount)) then
					GameTooltip:AddLine(name.." - "..amount.." "..type, 1.00, 1.00, 0.00, 1)
				else
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(name, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(name, 1.00, 1.00, 0.00, 1)
					end
				end
			end
			
		elseif (actionType == "item") then
			
			if ((SphereButtons.db.char.tooltiptype == "name") or (SphereButtons.db.char.tooltiptype == "namepower"))then
							
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine("Left Click", 1.00, 1.00, 0.00, 1)
				end
				
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine(name, 1.00, 1.00, 1.00, 1)
				else
					GameTooltip:AddLine(name, 1.00, 1.00, 0.00, 1)
				end
					
			end
	
		elseif (actionType == "macro") then

			if ((SphereButtons.db.char.tooltiptype == "name") or (SphereButtons.db.char.tooltiptype == "namepower"))then
				local macroName, texture, macrobody, localVar = GetMacroInfo(name);
				
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine("Left Click", 1.00, 1.00, 0.00, 1)
				end
				
				if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
					GameTooltip:AddLine(macroName, 1.00, 1.00, 1.00, 1)
				else
					GameTooltip:AddLine(macroName, 1.00, 1.00, 0.00, 1)
				end

			end
		
		end
		
		if ((SphereButtons.db.char.bData[buttonID].actionType2) and (SphereButtons.db.char.showallbuttonstooltips == "yes")) then
		
			if (actionType2 == "spell") then
		
				if (SphereButtons.db.char.tooltiptype == "name") then
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Right Click", 1.00, 1.00, 0.00, 1)
					end
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(name2, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(name2, 1.00, 1.00, 0.00, 1)
					end

				elseif (SphereButtons.db.char.tooltiptype == "power") then
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Right Click", 1.00, 1.00, 0.00, 1)
					end
				
					local type, amount = SphereButtons:CreateSpellTooltip(name2)

					if ((SphereButtons.db.char.showallbuttonstooltips == "yes") and (type) and (amount)) then
						GameTooltip:AddLine(amount.." "..type, 1.00, 1.00, 1.00, 1)
					elseif ((type) and (amount)) then
						GameTooltip:AddLine(amount.." "..type, 1.00, 1.00, 0.00, 1)
					end

				elseif (SphereButtons.db.char.tooltiptype == "namepower") then
			
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Right Click", 1.00, 1.00, 0.00, 1)
					end
				
					local type, amount = SphereButtons:CreateSpellTooltip(name2)

					if ((SphereButtons.db.char.showallbuttonstooltips == "yes") and (type) and (amount)) then
						GameTooltip:AddLine(name2.." - "..amount.." "..type, 1.00, 1.00, 1.00, 1)
					elseif ((type) and (amount)) then
						GameTooltip:AddLine(name2.." - "..amount.." "..type, 1.00, 1.00, 0.00, 1)
					else
						if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
							GameTooltip:AddLine(name2, 1.00, 1.00, 1.00, 1)
						else
							GameTooltip:AddLine(name2, 1.00, 1.00, 0.00, 1)
						end
					end
				end
			
			elseif (actionType2 == "item") then
			
				if ((SphereButtons.db.char.tooltiptype == "name") or (SphereButtons.db.char.tooltiptype == "namepower"))then
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Right Click", 1.00, 1.00, 0.00, 1)
					end
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(name2, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(name2, 1.00, 1.00, 0.00, 1)
					end
					
				end
	
			elseif (actionType2 == "macro") then

				if ((SphereButtons.db.char.tooltiptype == "name") or (SphereButtons.db.char.tooltiptype == "namepower"))then
					local macroName, texture, macrobody, localVar = GetMacroInfo(name2);
					
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Right Click", 1.00, 1.00, 0.00, 1)
					end
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(macroName, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(macroName, 1.00, 1.00, 0.00, 1)
					end

				end
				
			end
			
		end
			
		if ((SphereButtons.db.char.bData[buttonID].actionType3) and (SphereButtons.db.char.showallbuttonstooltips == "yes")) then
		
			if (actionType3 == "spell") then
		
				if (SphereButtons.db.char.tooltiptype == "name") then
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Middle Click", 1.00, 1.00, 0.00, 1)
					end
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(name3, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(name3, 1.00, 1.00, 0.00, 1)
					end

				elseif (SphereButtons.db.char.tooltiptype == "power") then
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Middle Click", 1.00, 1.00, 0.00, 1)
					end
				
					local type, amount = SphereButtons:CreateSpellTooltip(name3)

					if ((SphereButtons.db.char.showallbuttonstooltips == "yes") and (type) and (amount)) then
						GameTooltip:AddLine(amount.." "..type, 1.00, 1.00, 1.00, 1)
					elseif ((type) and (amount)) then
						GameTooltip:AddLine(amount.." "..type, 1.00, 1.00, 0.00, 1)
					end

				elseif (SphereButtons.db.char.tooltiptype == "namepower") then
			
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Middle Click", 1.00, 1.00, 0.00, 1)
					end
				
					local type, amount = SphereButtons:CreateSpellTooltip(name3)

					if ((SphereButtons.db.char.showallbuttonstooltips == "yes") and (type) and (amount)) then
						GameTooltip:AddLine(name3.." - "..amount.." "..type, 1.00, 1.00, 1.00, 1)
					elseif ((type) and (amount)) then
						GameTooltip:AddLine(name3.." - "..amount.." "..type, 1.00, 1.00, 0.00, 1)
					else
						if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
							GameTooltip:AddLine(name3, 1.00, 1.00, 1.00, 1)
						else
							GameTooltip:AddLine(name3, 1.00, 1.00, 0.00, 1)
						end
					end
				end
			
			elseif (actionType3 == "item") then
			
				if ((SphereButtons.db.char.tooltiptype == "name") or (SphereButtons.db.char.tooltiptype == "namepower"))then
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Middle Click", 1.00, 1.00, 0.00, 1)
					end
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(name3, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(name3, 1.00, 1.00, 0.00, 1)
					end
					
				end
	
			elseif (actionType3 == "macro") then

				if ((SphereButtons.db.char.tooltiptype == "name") or (SphereButtons.db.char.tooltiptype == "namepower"))then
					local macroName, texture, macrobody, localVar = GetMacroInfo(name3);
					
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine("", 1.00, 1.00, 0.00, 1)
						GameTooltip:AddLine("Middle Click", 1.00, 1.00, 0.00, 1)
					end
				
					if (SphereButtons.db.char.showallbuttonstooltips == "yes") then
						GameTooltip:AddLine(macroName, 1.00, 1.00, 1.00, 1)
					else
						GameTooltip:AddLine(macroName, 1.00, 1.00, 0.00, 1)
					end

				end
				
			end
		
		end
	
	end

	GameTooltip:Show();
	
end

--- ========================================================= ---
--- dragStart
--- ========================================================= ---

function SphereButtons:dragStart(this, dragID, dragName, clickType)

	if not(dragID) then
		return
	end

	if (SphereButtons.db.char.bData[dragID].empty) then
		return
	end

	local actionType = SphereButtons.db.char.bData[dragID]["actionType"..clickType]
	local name = SphereButtons.db.char.bData[dragID]["actionName"..clickType]
	local success = false;

	if (actionType == "spell") then
		PickupSpell(name)
		success = true;
	
	elseif (actionType == "item") then
	
		local b, s, i = nil;
		local iBag, iSlot = nil;
		local iInv = nil;
		
		--local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(info1)
		
		for b=0,4 do
			for s=1,GetContainerNumSlots(b) do
				if GetContainerItemLink(b,s) then
					if string.find(GetContainerItemLink(b,s),name) then
						iBag = b
						iSlot = s
					end
				end
			end
		end
		
		if ((iBag == nil) and (iSlot == nil)) then
			for i=0,23 do
				if GetInventoryItemLink("player",i) then
					if string.find(GetInventoryItemLink("player",i),name) then
						iInv = i
					end
				end
			end
		end
		
		if ((iBag) and (iSlot)) then
			PickupContainerItem(iBag, iSlot)
			success = true;
		elseif (iInv) then
			PickupInventoryItem(iInv)
			success = true;
		end

	
	elseif (actionType == "macro") then
		PickupMacro(name)
		success = true;
	end
	
	if (success) then
		
		if (SphereButtons.db.char.bData[dragID]["actionType"..clickType]) then
			SphereButtons.db.char.bData[dragID]["actionType"..clickType] = nil
		end
		
		if (SphereButtons.db.char.bData[dragID]["actionName"..clickType]) then
			SphereButtons.db.char.bData[dragID]["actionName"..clickType] = nil
		end
		
		if (clickType == 1) then
			getglobal(dragName .. "Icon"):SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background");
			SetPortraitToTexture(getglobal(dragName .. "Icon"), getglobal(dragName .. "Icon"):GetTexture());
			getglobal(dragName .. "Icon"):SetAlpha(0.5);
			
			getglobal(dragName .. "Count"):SetText("");
			getglobal(dragName .. "Count"):Hide();
			
			getglobal(dragName):SetChecked(0)
			
			getglobal(SphereButtons.db.char.bData[index].buttonname).cooldownText:Hide()
		end
		
		getglobal(dragName):SetAttribute("type-S0" .. clickType, "spell")
		getglobal(dragName):SetAttribute("spell-S0" .. clickType, "")
		
		if (not(SphereButtons.db.char.bData[dragID].actionType1) and not(SphereButtons.db.char.bData[dragID].actionType2) and not(SphereButtons.db.char.bData[dragID].actionType3)) then
			SphereButtons.db.char.bData[dragID].empty = true;
		end
		
		SphereButtons:LoadButton(dragID)
	end
	
end

--- ========================================================= ---
--- Assign Button
--- ========================================================= ---

function SphereButtons:SetButtonAssign(this, clickType, actionType, info1, info2)
	
	local buttonID = this:GetID();
	local buttonName = this:GetName();
	
	if (actionType == "spell") then

		local spellName, spellRank = GetSpellName(info1, info2);
		local spellTexture = GetSpellTexture(info1, info2);
		
		if (clickType == 1) then
			getglobal(buttonName .. "Icon"):SetTexture(spellTexture);
			SetPortraitToTexture(getglobal(buttonName .. "Icon"), getglobal(buttonName .. "Icon"):GetTexture());
			
			getglobal(buttonName .. "Icon"):SetWidth("22");
			getglobal(buttonName .. "Icon"):SetHeight("22")
			getglobal(buttonName .. "Icon"):SetAlpha(1);
		end
		
		this:SetAttribute("type-S0" .. clickType, actionType)
		this:SetAttribute(actionType .. "-S0" .. clickType, spellName)
		
		this:SetScript("OnUpdate", nil);
		
		SphereButtons:SaveButton(buttonID, buttonName, clickType, actionType, spellName)

	elseif (actionType == "item") then
		
		local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEquipLoc, iTexture = GetItemInfo(info1);
		
		if (clickType == 1) then
			getglobal(buttonName .. "Icon"):SetTexture(iTexture);
			SetPortraitToTexture(getglobal(buttonName .. "Icon"), getglobal(buttonName .. "Icon"):GetTexture());
		
			if ((iStackCount > 1) and (SphereButtons.db.char.showitemcounts)) then
				getglobal(buttonName .. "Count"):SetText(GetItemCount(info1));
				getglobal(buttonName .. "Count"):Show();
			else
				getglobal(buttonName .. "Count"):SetText("");
				getglobal(buttonName .. "Count"):Hide();
			end
		end
		
		getglobal(buttonName .. "Icon"):SetWidth("22");
		getglobal(buttonName .. "Icon"):SetHeight("22")
		getglobal(buttonName .. "Icon"):SetAlpha(1);
		
		this:SetAttribute("type-S0" .. clickType, actionType)
		this:SetAttribute(actionType .. "-S0" .. clickType, sName)
		
		this:SetScript("OnUpdate", nil);
		
		SphereButtons:SaveButton(buttonID, buttonName, clickType, actionType, sName)

	elseif (actionType == "macro") then

		local macroName, texture, macrobody, localVar = GetMacroInfo(info1);
		
		if (clickType == 1) then
			getglobal(buttonName .. "Icon"):SetTexture(texture);
			SetPortraitToTexture(getglobal(buttonName .. "Icon"), getglobal(buttonName .. "Icon"):GetTexture());
		end
		
		getglobal(buttonName .. "Icon"):SetWidth("22");
		getglobal(buttonName .. "Icon"):SetHeight("22")
		getglobal(buttonName .. "Icon"):SetAlpha(1);
		
		this:SetAttribute("type-S0" .. clickType, actionType)
		this:SetAttribute(actionType .. "-S0" .. clickType, macroName)
		
		this:SetScript("OnUpdate", nil);
		
		SphereButtons:SaveButton(buttonID, buttonName, clickType, actionType, info1)
	end
	
	ClearCursor();	
end

--- ========================================================= ---
--- Save Button
--- ========================================================= ---

function SphereButtons:SaveButton(buttonID, ButtonName, clickType, actionType, name)

	if (SphereButtons.db.char.bData[buttonID]) then

		SphereButtons.db.char.bData[buttonID].empty = nil
		SphereButtons.db.char.bData[buttonID].buttonid = buttonID
		SphereButtons.db.char.bData[buttonID].buttonname = ButtonName
		
		SphereButtons.db.char.bData[buttonID]["actionType"..clickType] = actionType
		SphereButtons.db.char.bData[buttonID]["actionName"..clickType] = name
		
	end

end

--- ========================================================= ---
--- Load Button
--- ========================================================= ---

function SphereButtons:LoadButton(button)

	if (SphereButtons.db.char.bData[button].empty) then
		return
	end

	local buttonID = SphereButtons.db.char.bData[button].buttonid
	local buttonName = SphereButtons.db.char.bData[button].buttonname
	
	for index=1, 3 do 
	
		if SphereButtons.db.char.bData[button]["actionType"..index] then
			
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEquipLoc, texture, macroName, macrobody, localVar
			local actionType = SphereButtons.db.char.bData[button]["actionType"..index]
			local name = SphereButtons.db.char.bData[button]["actionName"..index]
			
			getglobal(buttonName .. "Icon"):SetWidth("22");
			getglobal(buttonName .. "Icon"):SetHeight("22")
			getglobal(buttonName .. "Icon"):SetAlpha(1);
			
			getglobal(buttonName):SetWidth(36);
			getglobal(buttonName):SetAttribute("width", 36);
		
			getglobal(buttonName):SetAttribute("type-S0" .. index, actionType)
			
			if (actionType == "macro") then
				local macroName, texture, macrobody, localVar = GetMacroInfo(name);
				getglobal(buttonName):SetAttribute(actionType .. "-S0" .. index, macroName)
			else
				getglobal(buttonName):SetAttribute(actionType .. "-S0" .. index, name)
			end
			
			if (index == 1) then
				if (actionType == "spell") then
					texture = GetSpellTexture(name);
				elseif (actionType == "item") then
					sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEquipLoc, texture = GetItemInfo(name);
				elseif (actionType == "macro") then
					macroName, texture, macrobody, localVar = GetMacroInfo(name);
				end
					
				getglobal(buttonName .. "Icon"):SetTexture(texture);
				SetPortraitToTexture(getglobal(buttonName .. "Icon"), getglobal(buttonName .. "Icon"):GetTexture());
			end
				
			if (actionType == "item") then
		
				local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEquipLoc, iTexture = GetItemInfo(name);
		
				if (index == 1) then
					if (iStackCount) then
						if ((iStackCount > 1) and (SphereButtons.db.char.showitemcounts)) then
							getglobal(buttonName .. "Count"):SetText(GetItemCount(name));
							getglobal(buttonName .. "Count"):Show();
						else
							getglobal(buttonName .. "Count"):SetText("");
							getglobal(buttonName .. "Count"):Hide();
						end
					else
						getglobal(buttonName .. "Count"):SetText("");
						getglobal(buttonName .. "Count"):Hide();
					end
				end
				
				if (IsEquippedItem(sName)) then
					getglobal(buttonName):SetChecked(1)
					getglobal(buttonName):GetCheckedTexture():SetVertexColor(SphereButtons.db.char.itemequippedbordercolor.r, SphereButtons.db.char.itemequippedbordercolor.g, SphereButtons.db.char.itemequippedbordercolor.b, SphereButtons.db.char.itemequippedbordercolor.a);
				else
					getglobal(buttonName):SetChecked(0)
					getglobal(buttonName):GetCheckedTexture():SetVertexColor(SphereButtons.db.char.itemequippedbordercolor.r, SphereButtons.db.char.itemequippedbordercolor.g, SphereButtons.db.char.itemequippedbordercolor.b, SphereButtons.db.char.itemequippedbordercolor.a);
				end
				
			end
			
		end

	end
	
	getglobal(buttonName):SetAttribute("showstates", "!0,1");
	getglobal(buttonName):RegisterEvent("ACTIONBAR_UPDATE_STATE");

end

--- ========================================================= ---
--- Update Buttons
--- ========================================================= ---

function SphereButtons:UpdateButtons()

	SphereButtons:UpdateCooldowns()
	SphereButtons:UpdateUsable()
	SphereButtons:UpdateMacros()
	
end

--- ========================================================= ---
--- Update Cooldowns
--- ========================================================= ---

function SphereButtons:UpdateCooldowns()

	if not(SphereButtons.db.char.showcooldown) then
		for index=1, data.buttonCount do
			if not(SphereButtons.db.char.bData[index].empty) then 
				getglobal(SphereButtons.db.char.bData[index].buttonname).cooldownText:Hide()
			end
		end
		return;
	end

	local cooldown = 0;
	local timeDisplay = nil;
	local start, duration, enable;

	for index=1, data.buttonCount do

		if ((SphereButtons.db.char.bData[index].actionType1 == "spell") or (SphereButtons.db.char.bData[index].actionType1 == "item")) then
							
			local name, start, duration, enable;
							
			name = SphereButtons.db.char.bData[index].actionName1;
							
			if (SphereButtons.db.char.bData[index].actionType1 == "spell") then
				start, duration, enable = GetSpellCooldown(name)
			elseif (SphereButtons.db.char.bData[index].actionType1 == "item") then
				start, duration, enable = GetItemCooldown(name)
			end
							
			local buttonName = SphereButtons.db.char.bData[index].buttonname

			if ( start > 0 and duration > 0) then
				cooldown =duration - ( GetTime() - start);
										
				if (cooldown >= 86400) then
					cooldown = floor(cooldown / 86400);
					timeDisplay = "d"
				elseif (cooldown >= 3600) then
					cooldown = floor(cooldown / 3600);
					timeDisplay = "h"
				elseif (cooldown >= 60) then
					cooldown = floor(cooldown / 60);
					timeDisplay = "m"
				else 
					cooldown = floor(cooldown);
					timeDisplay = "s"
				end
								
				getglobal(buttonName).cooldownText:SetText(cooldown..""..timeDisplay);
				getglobal(buttonName).cooldownText:Show()
			else
				getglobal(buttonName).cooldownText:SetText("");
				getglobal(buttonName).cooldownText:Hide()
			end
		end
	end
end

--- ========================================================= ---
--- Update Usable
--- ========================================================= ---

function SphereButtons:UpdateUsable()

	if not(SphereButtons.db.char.showusable) then
		for index=1, data.buttonCount do
			if (SphereButtons.db.char.bData[index].empty) then 
				getglobal(SphereButtons.db.char.bData[index].buttonname .. "Icon"):SetVertexColor(1.0, 1.0, 1.0);
			end
		end
		return;
	end

	for index=1, data.buttonCount do
		if ((SphereButtons.db.char.bData[index].actionType1 == "spell") or (SphereButtons.db.char.bData[index].actionType1 == "item")) then

			local buttonName, name, usable, nomana;

			buttonName = SphereButtons.db.char.bData[index].buttonname;
			name = SphereButtons.db.char.bData[index].actionName1
							
			if (SphereButtons.db.char.bData[index].actionType1 == "spell") then
				usable, nomana = IsUsableSpell(name);
				inRange = IsSpellInRange(name, "target")
			elseif (SphereButtons.db.char.bData[index].actionType1 == "item") then
				usable = IsUsableItem(name);
				inRange = IsItemInRange(name, "target")
			end
			
			if (SphereButtons.db.char.bData[index].actionType1 == "item") then
				local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEquipLoc, iTexture = GetItemInfo(name);
				if (IsEquippedItem(sName)) then
					getglobal(buttonName):SetChecked(1)
					getglobal(buttonName):GetCheckedTexture():SetVertexColor(SphereButtons.db.char.itemequippedbordercolor.r, SphereButtons.db.char.itemequippedbordercolor.g, SphereButtons.db.char.itemequippedbordercolor.b, SphereButtons.db.char.itemequippedbordercolor.a);
				else
					getglobal(buttonName):SetChecked(0)
					getglobal(buttonName):GetCheckedTexture():SetVertexColor(SphereButtons.db.char.itemequippedbordercolor.r, SphereButtons.db.char.itemequippedbordercolor.g, SphereButtons.db.char.itemequippedbordercolor.b, SphereButtons.db.char.itemequippedbordercolor.a);
				end
			end
				
 			if (usable) then
				if (inRange == 0) then
					getglobal(buttonName .. "Icon"):SetVertexColor(SphereButtons.db.char.oorcolor.r, SphereButtons.db.char.oorcolor.g, SphereButtons.db.char.oorcolor.b, SphereButtons.db.char.oorcolor.a);
				else
					getglobal(buttonName .. "Icon"):SetVertexColor(1.0, 1.0, 1.0);
				end
			elseif ((SphereButtons.db.char.bData[index].actionType1 == "spell") and (nomana)) then
				if (inRange == 0) then
					getglobal(buttonName .. "Icon"):SetVertexColor(SphereButtons.db.char.oormcolor.r, SphereButtons.db.char.oormcolor.g, SphereButtons.db.char.oormcolor.b, SphereButtons.db.char.oormcolor.a);
				else
					getglobal(buttonName .. "Icon"):SetVertexColor(SphereButtons.db.char.oomcolor.r, SphereButtons.db.char.oomcolor.g, SphereButtons.db.char.oomcolor.b, SphereButtons.db.char.oomcolor.a);
				end 
			else 
				getglobal(buttonName .. "Icon"):SetVertexColor(SphereButtons.db.char.unusablecolor.r, SphereButtons.db.char.unusablecolor.g, SphereButtons.db.char.unusablecolor.b, SphereButtons.db.char.unusablecolor.a);
			end
		end
	end
end

--- ========================================================= ---
--- Update Item Counts
--- ========================================================= ---

function SphereButtons:UpdateItemCounts()

	for index=1, data.buttonCount do
	
		if (SphereButtons.db.char.bData[index].actionType1 == "item") then
		
			local name = SphereButtons.db.char.bData[index].actionName1
			local buttonName = SphereButtons.db.char.bData[index].buttonname
		
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEquipLoc, iTexture = GetItemInfo(name);
		
			if (index == 1) then
				if (iStackCount) then
					if ((iStackCount > 1) and (SphereButtons.db.char.showitemcounts)) then
						getglobal(buttonName .. "Count"):SetText(GetItemCount(name));
						getglobal(buttonName .. "Count"):Show();
					else
						getglobal(buttonName .. "Count"):SetText("");
						getglobal(buttonName .. "Count"):Hide();
					end
				else
					getglobal(buttonName .. "Count"):SetText("");
					getglobal(buttonName .. "Count"):Hide();
				end
			end
			
		end
		
	end
end

--- ========================================================= ---
--- Update Macros
--- ========================================================= ---

function SphereButtons:UpdateMacros()

	for index=1, data.buttonCount do
		if (SphereButtons.db.char.bData[index].actionType1 == "macro") then

			local buttonName = SphereButtons.db.char.bData[index].buttonname;
			local name = SphereButtons.db.char.bData[index].actionName1
							
			local macroName, texture, macrobody, localVar = GetMacroInfo(name);
		
			getglobal(buttonName .. "Icon"):SetTexture(texture);
			SetPortraitToTexture(getglobal(buttonName .. "Icon"), getglobal(buttonName .. "Icon"):GetTexture());
		end
	end
end